<script>
import Chart from "chart.js/auto";

export default {
  name: "ProceedingStatisticsProceedingsByDistricts",
  data () {
    // do not put this inside the return-statement (https://stackoverflow.com/a/68606394), 19.10.2022 Christa Becker
    this.drawnChart = null;
    return {
      displayType: "charts",
      chartOptions: {
        type: "pie",
        options: {
          maintainAspectRatio: false,
          responsive: true,
          plugins: {
            legend: {
              display: true,
              position: "bottom",
              align: "start"
            },
            tooltip: {
              enabled: true
            }
          }
        }
      }
    };
  },
  computed: {
    proceedingsByDistricts () {
      return this.$store.getters.proceedingsByDistricts;
    },
    formattedChartData () {
      return {
        labels: this.proceedingsByDistricts.map(entry => entry.district),
        datasets: [{
          backgroundColor: this.proceedingsByDistricts.map(entry => "rgb(" + Object.values(this.$hex2rgb(entry.color)).join(", ") + ")"),
          data: this.proceedingsByDistricts.map(entry => entry.count)
        }]
      };
    }
  },
  watch: {
    formattedChartData: {
      deep: true,
      handler () {
        this.initChart();
      }
    }
  },
  mounted () {
    this.initChart();
  },
  methods: {
    initChart () {
      if (this.proceedingsByDistricts.length) {
        if (this.drawnChart) {
          this.drawnChart.data = this.formattedChartData;
          this.drawnChart.update("none");
        }
        else {
          this.drawnChart = new Chart(
            this.$refs.chart.getContext("2d"),
            JSON.parse(JSON.stringify(this.$mergeDeep(this.chartOptions, {data: this.formattedChartData})))
          );
        }

        this.drawnChart.canvas.parentNode.style.height = (this.proceedingsByDistricts.length * 20 + 200) + "px";
      }
    },
    setDisplayType (type) {
      this.displayType = type;
    },
    translate (tid) {
      return this.$t(tid);
    }
  }
};
</script>

<template>
  <section class="ProceedingStatisticsProceedingsByDistricts">
    <h3>
      {{ $t("components.ProceedingStatisticsProceedingsByDistricts.headline") }}
    </h3>

    <div
      v-show="displayType === 'charts'"
      class="canvasContainer"
    >
      <canvas
        ref="chart"
        :alt="translate('components.ProceedingStatisticsProceedingsByDistricts.altTextCanvas')"
      />
    </div>

    <table v-show="displayType === 'tables'">
      <thead>
        <tr>
          <th id="districtname">
            {{ $t("components.ProceedingStatisticsProceedingsByDistricts.tableHead.columnDistrict") }}
          </th>
          <th id="districtcount">
            {{ $t("components.ProceedingStatisticsProceedingsByDistricts.tableHead.columnCount") }}
          </th>
          <th id="districtpercent">
            {{ $t("components.ProceedingStatisticsProceedingsByDistricts.tableHead.columnPercentage") }}
          </th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="data in proceedingsByDistricts"
          :key="'row-' + data.district"
        >
          <td headers="districtname">
            {{ data.district }}
          </td>
          <td headers="districtcount">
            {{ data.count }}
          </td>
          <td headers="districtpercent">
            {{ data.percentage }}%
          </td>
        </tr>
      </tbody>
    </table>
  </section>
</template>

<style lang="scss">
@import "../../../scss/_global.scss";

section.ProceedingStatisticsProceedingsByDistricts {
  div.canvasContainer {
    position: relative;
  }
}
</style>
